config/routes.rb
Rails.application.routes.draw do
  resources :conversations do
    resource :conversation_user
    resources :messages
  end
  resources :reservations, path_names: { new: 'new/:location_id' }
  resources :favoris, path_names: { new: 'new/:location_id' }
  resources :avis, path_names: { new: 'new/:location_id' }
  resources :categories
  resources :equipements, path_names: { new: 'new/:location_id' }
  devise_for :users
  resources :locations
  resources :searches
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  root to: "locations#index"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/avi.rb
class Avi < ApplicationRecord
end

app/models/category.rb
class Category < ApplicationRecord
end

app/models/conversation.rb
class Conversation < ApplicationRecord
    has_many :conversation_users, dependent: :destroy
    has_many :users, through: :conversation_users
    has_many :messages, dependent: :destroy

    validates :name, presence: true
end

app/models/conversation_user.rb
class ConversationUser < ApplicationRecord
  belongs_to :conversation
  belongs_to :user
end

app/models/equipement.rb
class Equipement < ApplicationRecord
end

app/models/favori.rb
class Favori < ApplicationRecord
end

app/models/location.rb
class Location < ApplicationRecord
  def self.search(search)
    if search
      where(["titre LIKE ?","%#{search}%"])
    else
      all
    end
  end
end

app/models/message.rb
class Message < ApplicationRecord
  belongs_to :conversation
  belongs_to :user
end

app/models/reservation.rb
class Reservation < ApplicationRecord
end

app/models/search.rb
class Search < ApplicationRecord
  def search_locations
    locations = Location.all

    locations = locations.where(["titre LIKE ?","%#{keywords}%"]) if keywords.present?
    locations = locations.where(["v_type LIKE ?", v_type]) if v_type.present?

    locations = locations.where(["zip LIKE ?", zip]) if zip.present?
    locations = locations.where(["city LIKE ?", "%#{city}%"]) if city.present?


    locations = locations.where(["price >= ?", min_price]) if min_price.present?
    locations = locations.where(["price <= ?", max_price]) if max_price.present?

    locations = locations.where(["nbChambre >= ?", min_nbChambre]) if min_nbChambre.present?
    locations = locations.where(["nbChambre <= ?", max_nbChambre]) if max_nbChambre.present?

    locations = locations.where(["nbCouchage >= ?", min_nbCouchage]) if min_nbCouchage.present?
    locations = locations.where(["nbCouchage <= ?", max_nbCouchage]) if max_nbCouchage.present?

    return locations
  end
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable, :confirmable
  
  has_many :conversation_users, dependent: :destroy
  has_many :conversations, through: :conversation_users
  has_many :messages, dependent: :destroy
end

app/controllers/avis_controller.rb
class AvisController < ApplicationController
  before_action :authenticate_user!
  before_action :set_avi, only: %i[ show edit update destroy ]

  # GET /avis or /avis.json
  def index
    @avis = Avi.where(user_id: current_user.id)
    @locations = Location.all
  end

  # GET /avis/1 or /avis/1.json
  def show
  end

  # GET /avis/new
  def new
    @avi = Avi.new
  end

  # GET /avis/1/edit
  def edit
  end

  # POST /avis or /avis.json
  def create
    @avi = Avi.new(avi_params)
    @avi.user_id = current_user.id
    @avi.location_id = params[:location_id]

    respond_to do |format|
      if @avi.save

        # RECALCULER LA NOTE MOYENE D'UN LOGEMENT
        @avis_location = Avi.where(location_id: params[:location_id])
        @location = Location.find(params[:location_id])
        @new_avg_rate = 0.0
        @avis_location.each do |avi_location|
          @new_avg_rate = @new_avg_rate + avi_location.note
        end

        if @avis_location.count >= 1
          @location.avg_rate = (@new_avg_rate/@avis_location.count).round(1)
        else
          @location.avg_rate = 11
        end
        
        @location.save

        format.html { redirect_to @location, notice: "Votre avis a été ajouté avec succès" }
        format.json { render :show, status: :created, location: @location }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @avi.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /avis/1 or /avis/1.json
  def update
    respond_to do |format|
      if @avi.update(avi_params)

        # RECALCULER LA NOTE MOYENE D'UN LOGEMENT
        @avis_location = Avi.where(location_id: @avi.location_id)
        @location = Location.find(@avi.location_id)
        @new_avg_rate = 0.0
        @avis_location.each do |avi_location|
          @new_avg_rate = @new_avg_rate + avi_location.note
        end

        if @avis_location.count >= 1
          @location.avg_rate = (@new_avg_rate/@avis_location.count).round(1)
        else
          @location.avg_rate = 11
        end

        @location.save

        format.html { redirect_to @location, notice: "Votre avis a correctement été mis à jour" }
        format.json { render :show, status: :ok, location: @location }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @avi.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /avis/1 or /avis/1.json
  def destroy
    @avi.destroy

    # RECALCULER LA NOTE MOYENE D'UN LOGEMENT
    @avis_location = Avi.where(location_id: @avi.location_id)
    @location = Location.find(@avi.location_id)
    @new_avg_rate = 0.0
    @avis_location.each do |avi_location|
      @new_avg_rate = @new_avg_rate + avi_location.note
    end

    if @avis_location.count >= 1
      @location.avg_rate = (@new_avg_rate/@avis_location.count).round(1)
    else
      @location.avg_rate = 11
    end

    @location.save

    respond_to do |format|
      format.html { redirect_to avis_url, notice: "Votre avis a correctement été supprimé" }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_avi
      @avi = Avi.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def avi_params
      params.require(:avi).permit(:note, :comment)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/avis_helper.rb
module AvisHelper
end

app/helpers/categories_helper.rb
module CategoriesHelper
end

app/helpers/equipements_helper.rb
module EquipementsHelper
end

app/helpers/favoris_helper.rb
module FavorisHelper
end

app/helpers/locations_helper.rb
module LocationsHelper
end

app/helpers/searches_helper.rb
module SearchesHelper
end

app/views/layouts/_messages.html.erb
<% if notice %>
    <p class="alert alert-success"><%= notice %></p>
<% end %>
<% if alert %>
    <p class="alert alert-danger"><%= alert %></p>
<% end %>

app/views/layouts/_navbar.html.erb
<nav class="navbar navbar-expand-lg navbar-dark bg-dark">
  <div class="container-fluid">

    <%= link_to 'Airbnb', locations_path, class: "navbar-brand" %>
    <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
      <span class="navbar-toggler-icon"></span>
    </button>
    <div class="collapse navbar-collapse" id="navbarSupportedContent">
      <ul class="navbar-nav me-auto mb-2 mb-lg-0">
        <li class="nav-item">
            <%= link_to 'Locations', locations_path, class: "nav-link active" %>
        </li>
        <li class="nav-item">
          <%= link_to 'Mes réservations', reservations_path, class: "nav-link active" %>
        </li>
        <li class="nav-item">
          <%= link_to 'Mes Avis', avis_path, class: "nav-link active" %>
        </li>
        <li class="nav-item">
          <%= link_to 'Favoris', favoris_path, class: "nav-link active" %>
        </li>
        <!--<li class="nav-item">
          <%= link_to 'Equipements', equipements_path, class: "nav-link active" %>
        </li>-->
        <li class="nav-item">
          <%= link_to 'Catégories', categories_path, class: "nav-link active" %>
        </li>
        <li class="nav-item">
          <%= link_to ' ㅤㅤㅤ', "https://www.youtube.com/watch?v=dQw4w9WgXcQ", class: "nav-link active" %>
        </li>


      </ul>
      <form class="d-flex">
        <% if user_signed_in? %>
          <div class="input-group">
            <div class="input-group-append">
             <%= link_to "Mon Profil", edit_user_registration_path, class: 'btn btn-primary',:style => "color: white;" %>
             <%= link_to destroy_user_session_path, class: 'btn btn-danger ',:style => "color: white" , :method => :delete do %>Déconnexion<% end %>
            </div>
          </div>

        <% else %>
            <%= link_to new_user_registration_path, class: 'btn btn-light' do %><i class="fas fa-sign-in-alt"></i> Inscription<% end %>
            <%= link_to new_user_session_path, class: 'btn btn-dark' do %><i class="fas fa-sign-in-alt"></i> Connexion<% end %>
        <% end %>
      </form>
    </div>
  </div>
</nav>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Airbnb</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.0.0-beta3/css/all.min.css" integrity="sha512-Fo3rlrZj/k7ujTnHg4CGR2D7kSs0v4LLanw2qksYuRlEzO+tcaEPQogQ0KaoGN26/zrn20ImR1DfuLWnOo7aBA==" crossorigin="anonymous" referrerpolicy="no-referrer" />
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
    <%= favicon_link_tag asset_path('airbnb-icon.png') %>
    <%= javascript_include_tag "jquery", "jquery_ujs" %>
  </head>

  <body>
    <header>
        <%= render '/layouts/navbar' %>
    </header>
    <div class="p-2">
      <%= render '/layouts/messages' %>
    </div>

    <div class="container">
      <%= yield %>
    </div>
  </body>
</html>